db.getMongo().setReadPref('secondary');

var map = {}
db.getCollection('user_variables').find({
	platform:'instagram', 
    platformBotId:'', 
    $or: [
        {name: 'User_Query'}
    ],
    value: {$not: /.*devnull.*/}, 
    lastUpdatedDate: {$gt: ISODate("2024-06-28 02:16:01Z")}
}).forEach((doc) => {
	if(!map[doc.platformUserId]) {
		map[doc.platformUserId] = {};
	}
	if(doc.name === 'User_Query') {
		map[doc.platformUserId].query = doc.value;
	}
})

var platformUserIds = Object.keys(map);

db.getCollection('platform_users').find({platform:'instagram', botId:'', platformUserId: {$in: platformUserIds}}).forEach((doc) => {
	if(doc.firstName) {
    	map[doc.platformUserId]['firstName'] = doc.firstName;
    }
    if(doc.lastName) {
    	map[doc.platformUserId]['lastName'] = doc.lastName;
    }
})
print('PSID, FirstName, LastName, Query')
for(psid in map) {
    var firstName = map[psid]['firstName'] || '';
    var lastName = map[psid]['lastName'] || '';
    var query = map[psid]['query'] || '';
  	print(psid + ',' + firstName + ',' + lastName + ',' + query);
}
