db.getMongo().setReadPref("secondary");

const accountNameMap = {},
    couponCodeUsage = {};

// prettier-ignore
db.getCollection("accounts").find({}).forEach((doc) => {
    if (doc && doc.name) {
        accountNameMap[doc._id.str] = doc.name;
    }
});

// prettier-ignore
db.getCollection("codes").find({}).forEach((doc) => {
    if (doc && doc.uses && accountNameMap[doc.accountId]) {
        if(!couponCodeUsage[doc.accountId]) {
            couponCodeUsage[doc.accountId] = {
                name: accountNameMap[doc.accountId], coupons:{}
            };
        }
        if(!couponCodeUsage[doc.accountId].coupons[doc.codeId]) {
            couponCodeUsage[doc.accountId].coupons[doc.codeId] = {
                total:0,
                served: 0,
                remaining: 0,
                reuseThreshold: 1
            };
        }
        if(doc.uses > couponCodeUsage[doc.accountId].coupons[doc.codeId].reuseThreshold) {
            couponCodeUsage[doc.accountId].coupons[doc.codeId].reuseThreshold = doc.uses
        }
        couponCodeUsage[doc.accountId].coupons[doc.codeId].total += 1 * doc.uses;
        couponCodeUsage[doc.accountId].coupons[doc.codeId].served += doc.used;
        const remaining = (doc.uses - doc.used);
        if (remaining) {
            couponCodeUsage[doc.accountId].coupons[doc.codeId].remaining += remaining;
        }
    }
});

writeFile("./CouponCodeUsage.json", JSON.stringify({ data: couponCodeUsage }));
