db.getMongo().setReadPref("secondary");

const map = {},
    botIds = [], 
    filteredMap = {},
	accountMap = {};
// prettier-ignore
db.getCollection('accounts').find({}).forEach((doc) => {
	accountMap[doc._id.valueOf()] = doc.name;
})

// prettier-ignore
db.getCollection('platform_bots').find({platform: "twilio_sms", invalid: {$ne: true}, isDeleted: {$ne: true}, platformBotId: /^MG.*/}).forEach((doc) => {
        	if(doc){
            map[doc.botId] = {
          		name: doc.name,
          		botId: doc.botId,
          		platformBotId: doc.platformBotId
                //accountSID: doc.config.accountSid || "",
                //twilioAuthToken: doc.config.authToken || ""
    		};
            if(doc.config && doc.config.accountSid){
            map[doc.botId].accountSID  = doc.config.accountSid
            }
            if( doc.config && doc.config.authToken){
            map[doc.botId].twilioAuthToken  = doc.config.authToken
            }
    	botIds.push(ObjectId(doc.botId))
        }
})

// prettier-ignore
db.getCollection('bots').find({_id: {$in: botIds}, $or:[{name:/cliqz/},{type:"cliqz"}]}).forEach((doc) => {
	const botId = doc._id.valueOf();
    filteredMap[botId] = {
    	botId,
    	name: doc.name,
        accountId: doc.account,
        accountName: accountMap[doc.account] || "", 
        platformBotId: map[botId].platformBotId,
        accountSID: map[botId].accountSID || "",
        twilioAuthToken: map[botId].twilioAuthToken || "",
        amplifyAccessToken: doc.config.accessToken || "",
    }
})

printjson(filteredMap);
