const fs = require('fs');
const request = require('request-promise-native');

const filePath = process.argv[2]

const botId = "" 
const startDate = "20240617";
const endDate = "20240623";
const startDateSimple = startDate.split("-").join('')
const endDateSimple = endDate.split("-").join('')

const GSHEETS_CONNECTOR_BASE_URL = "https://23pysf2rdf.execute-api.us-east-1.amazonaws.com/prod/";

// #1- total messages

function getTotalMessage(access_token, bot_id) {
        const options = {
        url: "https://api.amplify.ai/api/v1/analytics/message_count",
        headers: {
            'x-access-token': access_token,
            'accept': 'application/json',
            'content-type': 'application/json'
        },
        json: {
            accountId: "63dabf76ff86c4315608d509",
            botId: bot_id,
            startDate:  "20240617",
            endDate: "20240623",
        }
    }
    return request.post(options);
}

// #2- total sessions
        
function getSessions(access_token,bot_id) {
    const options = {
        url: 'https://api.amplify.ai/api/v1/analytics/engagement/messages_session',
        headers: {
            'x-access-token': access_token,
            'accept': 'application/json',
            'content-type': 'application/json'
        },
        json: {
             accountId: "63dabf76ff86c4315608d509",
            botId: bot_id,
            startDate:  "20240617",
            endDate: "20240623",
            "filters": []
        }
    }
    return request.post(options);
}

// #-3-  users change 
        
    function getUserChange(access_token, bot_id) {
    const options = {
        url: `https://api.amplify.ai/api/v1/analytics/user/change`,
        headers: {
            'x-access-token': access_token,
            'accept': 'application/json',
            'content-type': 'application/json'
        },
        json: {
              accountId: "63dabf76ff86c4315608d509",
            botId: bot_id,
            startDate:  "20240617",
            endDate: "20240623",
            "filters": []
        }
    }
    return request.post(options);
}
   
// # -4- subscribers

function getTotalSubs(access_token, bot_id) {
    const options = {
        url: `https://api.amplify.ai/api/v1/bots/${bot_id}/audience`,
        headers: {
            'x-access-token': access_token,
            'accept': 'application/json',
            'content-type': 'application/json'
        }
    }
    return request.get(options);
}
    
 function getOptInDetails(access_token, bot_id) {
    const options = {
        url: `https://api.amplify.ai/api/v1/analytics/other`,
        headers: {
            'x-access-token': access_token,
            'accept': 'application/json',
            'content-type': 'application/json'
        },
        json: {
             accountId: "63dabf76ff86c4315608d509",
            botId: bot_id,
            startDate:  "20240617",
            endDate: "20240623",
            "filters": [],
            aggregationFields: [
                "optedIn",
                "sent",
                ],
            groupByBucketLimit: 1000,    
            groupByField: "date",
            indexName: "notifications"
        }
    }
    return request.post(options);
}

// # -5- comments 

function getComments(access_token, bot_id) {
    const options = {
        url: `https://api.amplify.ai/api/v1/analytics/comments/growth`,
        headers: {
            'x-access-token': access_token,
            'accept': 'application/json',
            'content-type': 'application/json'
        },
        json: {
           accountId: "63dabf76ff86c4315608d509",
            botId: bot_id,
            startDate:  "20240617",
            endDate: "20240623",
            "filters": []
        }
    }
    return request.post(options);
}
    

// # -6- broadcasts 
function getBroadcasts(access_token, bot_id) {
    const options = {
        url: `https://api.amplify.ai/api/v1/analytics/broadcast/sent_message`,
        headers: {
            'x-access-token': access_token,
            'accept': 'application/json',
            'content-type': 'application/json'
        },
        json: {
            accountId: "63dabf76ff86c4315608d509",
            botId: bot_id,
            startDate:  "20240617",
            endDate: "20240623",
            "filters": []
        }
    }
    return request.post(options);
}
    
 function getBroadcastSession(access_token, bot_id) {
    const options = {
        url: `https://api.amplify.ai/api/v1/analytics/session`,
        headers: {
            'x-access-token': access_token,
            'accept': 'application/json',
            'content-type': 'application/json'
        },
        json: {
            accountId: "63dabf76ff86c4315608d509",
            botId: bot_id,
            startDate:  "20240617",
            endDate: "20240623",
            "filters": [
                {
                    field: "sessionStartType", 
                    eq: ["broadcast"]
                }
            ]
        }
    }
    return request.post(options);
}
 

 //  # main method receives all metrics and pushes it into an arrays for FB and IG

async function run() {

    const sheetData = [];
	 let dateRange = [];
     
     console.log(dateRange);
    dateRange.push(20240617 + ' -> ' + 20240623);
	sheetData.push(dateRange);
    
    const loginOptions = {
        url: 'https://api.amplify.ai/api/v1/login',
        headers: {
            'accept': 'application/json',
            'Content-Type': 'application/json'
        },
        json: {
             'username': 'jake+readonlyadmin@amplify.ai',
             'password': 'xixujebofacu'
        }
    }

    const loginRes = await request.post(loginOptions);
    const access_token = loginRes.access_token;


let bots = [];
let platforms =  [];

if ('63dabf82ff86c4315608d50c' != '') {
bots.push('63dabf82ff86c4315608d50c')
platforms.push('facebook')
}

if ('63dabf8aff86c4315608d50e' != '') {
bots.push('63dabf8aff86c4315608d50e')
platforms.push('instagram')
}

sheetData.push(platforms);

// #get messages count

let messagesRow = [];

	 let analyticsRes = await getTotalMessage(access_token, bots[0]);

    let messagesInCount = 0;
    let messagesOutCount = 0;

    analyticsRes.forEach((element) => {
        if(element.messagesIn) {
            messagesInCount += element.messagesIn;
        }
        if(element.messagesOut) {
            messagesOutCount += element.messagesOut;
        }
    })
    
    let totalMessages = messagesInCount + messagesOutCount;

     console.log(`messages in: ${messagesInCount}`)
    console.log(`messages out: ${messagesOutCount}`) 
    console.log(`messages out: ${totalMessages}`) 

	messagesRow.push(totalMessages);

	totalMessages = 0;
	
    if (bots.length > 1) {
	 analyticsRes = await getTotalMessage(access_token, bots[1]);

    messagesInCount = 0;
    messagesOutCount = 0;

    analyticsRes.forEach((element) => {
        if(element.messagesIn) {
            messagesInCount += element.messagesIn;
        }
        if(element.messagesOut) {
            messagesOutCount += element.messagesOut;
        }
    })
    
    totalMessages = messagesInCount + messagesOutCount;
    
    }
         console.log(`messages in: ${messagesInCount}`)
    console.log(`messages out: ${messagesOutCount}`) 
    console.log(`messages out: ${totalMessages}`) 
    messagesRow.push(totalMessages);
     sheetData.push(messagesRow);
   
     //# get session count  

	let sessionsItem = [];

     let sessionsRes = await getSessions(access_token, bots[0]);
    let sessionsCount = 0;
    sessionsRes.forEach((element) => {
        if(element.newSessions) {
            sessionsCount += element.newSessions;
        }
    })
    
    console.log(`sessionsCount: ${sessionsCount}`) 

sessionsItem.push(sessionsCount);

	sessionsCount = 0;
    
    if (bots.length > 1) {


      sessionsRes = await getSessions(access_token, bots[1]);
    sessionsCount = 0;
    sessionsRes.forEach((element) => {
        if(element.newSessions) {
            sessionsCount += element.newSessions;
        }
    })
    
    }
    console.log(`sessionsCount: ${sessionsCount}`) 

sessionsItem.push(sessionsCount);
    
    
   // # get user change
   
	let userItem = [];
    
      let userChangeRes = await getUserChange(access_token, bots[0]);
    let userChangeCount = 0;
    userChangeRes.forEach((element) => {
        if(element.new) {
            userChangeCount += element.new;
        }
    })
    
    console.log(`Total Users: ${userChangeCount}`) 

    userItem.push(userChangeCount);
    
    userChangeCount = 0;
    
        if (bots.length > 1) {

     userChangeRes = await getUserChange(access_token, bots[1]);
     userChangeCount = 0;
    userChangeRes.forEach((element) => {
        if(element.new) {
            userChangeCount += element.new;
        }
    })
    
}
    console.log(`Total Users: ${userChangeCount}`) 

userItem.push(userChangeCount);
       
    // # recurring users
    
    let recurringRow = [];
    
     let recurringRes = await getTotalSubs(access_token, bots[0]);

	let recurring = JSON.parse(recurringRes);
   
   	let recurringUsers = 0;
    
   if (recurring) {
    	 if (platforms[1] == 'facebook' && recurring.facebook) 
	    			recurringUsers = recurring.facebook['recurring'];
    
    	if (platforms[1] == 'instagram' && recurring.instagram) 
	   				recurringUsers = recurring.instagram['recurring'];
	}
    
    console.log(`recurringUsers: ${recurringUsers}`) 
        
    recurringRow.push(recurringUsers);
    
    recurringUsers = 0;
    
       if (bots.length > 1) {
    
      recurringRes = await getTotalSubs(access_token, bots[1]);

	recurring = JSON.parse(recurringRes);
   
   if (recurring) {
    	 if (platforms[0] == 'facebook' && recurring.facebook) 
	    			recurringUsers = recurring.facebook['recurring'];
    
    	if (platforms[0] == 'instagram' && recurring.instagram) 
	   				recurringUsers = recurring.instagram['recurring'];
	}
    
	}
    
            console.log(`recurringUsers: ${recurringUsers}`) 

    recurringRow.push(recurringUsers);

    // # opt in details
    
    optinSentItem = [];
    optedInItem = [];
    
     let optInsRes = await getOptInDetails(access_token, bots[0]);
    let optInSent = 0;
    let optedIn = 0;

    optInsRes.forEach((element) => {
    	if(element.sent) {
            optInSent += element.sent;
        }
        if(element.optedIn) {
            optedIn += element.optedIn;
        }
    })
    
    console.log(`Sent: ${optInSent}`) 
    console.log(`Opted In: ${optedIn}`) 
    
    optinSentItem.push(optInSent);
    optedInItem.push(optedIn);
    
        optInSent = 0;
   		optedIn = 0;
        
               if (bots.length > 1) {
    
      optInsRes = await getOptInDetails(access_token, bots[1]);


    optInsRes.forEach((element) => {
    	if(element.sent) {
            optInSent += element.sent;
        }
        if(element.optedIn) {
            optedIn += element.optedIn;
        }
    })
    
    }
        console.log(`Sent: ${optInSent}`) 
    console.log(`Opted In: ${optedIn}`) 
     optinSentItem.push(optInSent);
    optedInItem.push(optedIn);
    // # get comments
    
    
    let commentRep = [];
    let commentEng = [];
    
       let commentsRes = await getComments(access_token, bots[0]);

    let commentsReceived = 0;
    let commentsReplied = 0;
    let commentsRepliesEngaged = 0;

    commentsRes.forEach((element) => {
    	if(element.commentsReceived) {
            commentsReceived += element.commentsReceived;
        }
        if(element.commentsReplied) {
            commentsReplied += element.commentsReplied;
        }
        if(element.commentsRepliesEngaged) {
            commentsRepliesEngaged += element.commentsRepliesEngaged;
        }
    })
    
    console.log(`Received: ${commentsReceived}`) 
    console.log(`Replied: ${commentsReplied}`) 
    console.log(`Engaged: ${commentsRepliesEngaged}`) 
    
    commentRep.push(commentsReplied)
    commentEng.push(commentsRepliesEngaged)
    
    
        commentsReceived = 0;
    commentsReplied = 0;
    commentsRepliesEngaged = 0;
    
                if (bots.length > 1) { 
     commentsRes = await getComments(access_token, bots[1]);

    commentsRes.forEach((element) => {
    	if(element.commentsReceived) {
            commentsReceived += element.commentsReceived;
        }
        if(element.commentsReplied) {
            commentsReplied += element.commentsReplied;
        }
        if(element.commentsRepliesEngaged) {
            commentsRepliesEngaged += element.commentsRepliesEngaged;
        }
    })
     
    }
    
        
    console.log(`Received: ${commentsReceived}`) 
    console.log(`Replied: ${commentsReplied}`) 
    console.log(`Engaged: ${commentsRepliesEngaged}`) 
    
     commentRep.push(commentsReplied)
    commentEng.push(commentsRepliesEngaged)
    
    // # get broadcast details
    
    
   let broadcastSentItem = [];
   let broadcastReadItem = [];
    
       let broadcastsRes = await getBroadcasts(access_token, bots[0]);

    let broadcastSent = 0;
    let broadcastRead = 0;

    broadcastsRes.forEach((element) => {
    	if(element.sent) {
            broadcastSent += element.sent;
        }
        if(element.read) {
            broadcastRead += element.read;
        }
    })
    
    broadcastSentItem.push(broadcastSent);
    broadcastReadItem.push(broadcastRead);
    
    
         broadcastSent = 0;
     broadcastRead = 0;
    
      if (bots.length > 1) { 
      broadcastsRes = await getBroadcasts(access_token, bots[1]);



    broadcastsRes.forEach((element) => {
    	if(element.sent) {
            broadcastSent += element.sent;
        }
        if(element.read) {
            broadcastRead += element.read;
        }
    })

	}
 	broadcastSentItem.push(broadcastSent);
    broadcastReadItem.push(broadcastRead);
    
	let allClicksItem = [];
    let textInputsItem = [];

    let broadcastSessionRes = await getBroadcastSession(access_token, bots[0]);

    let allClicks = 0;
    let textInputs = 0;

    broadcastSessionRes.forEach((element) => {
    	if(element.allClicks) {
            allClicks += element.allClicks;
        }
        if(element.textInputs) {
            textInputs += element.textInputs;
        }
    })
    
    allClicksItem.push(allClicks)
    textInputsItem.push(textInputs)
    
         allClicks = 0;
    textInputs = 0;
    
       if (bots.length > 1) { 
     broadcastSessionRes = await getBroadcastSession(access_token, bots[1]);

    broadcastSessionRes.forEach((element) => {
    	if(element.allClicks) {
            allClicks += element.allClicks;
        }
        if(element.textInputs) {
            textInputs += element.textInputs;
        }
    })
    
}
   allClicksItem.push(allClicks)
    textInputsItem.push(textInputs)
    
     console.log(`Sent: ${broadcastSent}`) 
    console.log(`Read: ${broadcastRead}`) 
    console.log(`All Clicks: ${allClicks}`) 
    console.log(`Text Inputs: ${textInputs}`) 

    
   
	let totalConversationsRow = [];
    
     totalConversationsRow.push(sessionsItem[0] + (commentRep[0] - commentEng[0]));
	
     totalConversationsRow.push(sessionsItem[1] + (commentRep[1] - commentEng[1]));

     sheetData.push(totalConversationsRow);
     
	let conversationStartsRow = [];
    
   conversationStartsRow.push(userItem[0] + (commentRep[0] - commentEng[0]));
   conversationStartsRow.push(userItem[1] + (commentRep[1] - commentEng[1]));
   
   
     sheetData.push(conversationStartsRow);
     
      sheetData.push(['']);
      
     // #sheetData.push(['Total Sessions',sessionsCount]);
    // #sheetData.push(['New Users',userChangeCount]);
    
    
    
   sheetData.push(platforms);
	 // #sheetData.push(['Comments Received',commentsReceived]);
    sheetData.push(commentRep);
    sheetData.push(commentEng);
    
    let engagementRateRow = [];
    engagementRateRow.push(parseFloat((commentEng[0] / commentRep[0]) * 100).toFixed(0) + '%');
    engagementRateRow.push(parseFloat((commentEng[1] / commentRep[1]) * 100).toFixed(0) + '%');
     
     sheetData.push(engagementRateRow);
     
     
     
     sheetData.push(['=B11','=B11']);
           sheetData.push(['=OFFSET(INDIRECT(ADDRESS(ROW(), COLUMN())),-2,0)/OFFSET(INDIRECT(ADDRESS(ROW(), COLUMN())),-1,0)','=OFFSET(INDIRECT(ADDRESS(ROW(), COLUMN())),-2,0)/OFFSET(INDIRECT(ADDRESS(ROW(), COLUMN())),-1,0)']);

       sheetData.push(['']);
     sheetData.push(platforms);
       
  // # sheetData.push(recurringRow);
       sheetData.push(optedInItem);
    
   // # sheetData.push(['Opt-in Sent',optInSent]);
    // #sheetData.push(['Users Opted In for RN',optedIn]);

let optInRate = [];
	optInRate.push(parseFloat((optedInItem[0] / optinSentItem[0]) * 100).toFixed(0) + '%');
	optInRate.push(parseFloat((optedInItem[1] / optinSentItem[1]) * 100).toFixed(0) + '%');


    sheetData.push(optInRate);
     sheetData.push(['=B17','=B17']);
           sheetData.push(['=OFFSET(INDIRECT(ADDRESS(ROW(), COLUMN())),-2,0)/OFFSET(INDIRECT(ADDRESS(ROW(), COLUMN())),-1,0)','=OFFSET(INDIRECT(ADDRESS(ROW(), COLUMN())),-2,0)/OFFSET(INDIRECT(ADDRESS(ROW(), COLUMN())),-1,0)']);

      sheetData.push(['']);
     sheetData.push(platforms);
      
     sheetData.push(broadcastSentItem);
    sheetData.push(broadcastReadItem);
    
    let openRate = [];
    openRate.push(parseFloat((broadcastReadItem[0] / broadcastSentItem[0]) * 100).toFixed(0) + '%');
    openRate.push(parseFloat((broadcastReadItem[1] / broadcastSentItem[1]) * 100).toFixed(0) + '%');
    
     sheetData.push(openRate);
     
     sheetData.push(['=B24','=B24']);
           sheetData.push(['=OFFSET(INDIRECT(ADDRESS(ROW(), COLUMN())),-2,0)/OFFSET(INDIRECT(ADDRESS(ROW(), COLUMN())),-1,0)','=OFFSET(INDIRECT(ADDRESS(ROW(), COLUMN())),-2,0)/OFFSET(INDIRECT(ADDRESS(ROW(), COLUMN())),-1,0)']);

      
    let broadcastEngaged = [];
    
    broadcastEngaged.push(allClicksItem[0] + textInputsItem[0]);
    broadcastEngaged.push(allClicksItem[1] + textInputsItem[1]);
    
    sheetData.push(broadcastEngaged);
   
    let broadEngRate = [];
    
    broadEngRate.push(parseFloat((broadcastEngaged[0] / broadcastReadItem[0]) * 100).toFixed(0) + '%');
    broadEngRate.push(parseFloat((broadcastEngaged[1] / broadcastReadItem[1]) * 100).toFixed(0) + '%');


sheetData.push(broadEngRate);
sheetData.push(['=B28','=B28']);
           sheetData.push(['=OFFSET(INDIRECT(ADDRESS(ROW(), COLUMN())),-2,0)/OFFSET(INDIRECT(ADDRESS(ROW(), COLUMN())),-1,0)','=OFFSET(INDIRECT(ADDRESS(ROW(), COLUMN())),-2,0)/OFFSET(INDIRECT(ADDRESS(ROW(), COLUMN())),-1,0)']);

   // # sheetData.push(['All Clicks',allClicks]);
    // # sheetData.push(['Message Typed',textInputs]);
    
    console.log(sheetData);
    
    // #read number of written columns  
    const res = await getColumnsNumber();

	let colData = JSON.parse(res);
     let col = colData['data'][0];
	console.log(col);

		let colNum = col.length;


	for (let i = 0; i < col.length; i++) {
		
		if (col[i] == ''){	
			colNum = i;
			break;
		}
	}

console.log(colNum);
     
   send(sheetData, colNum)
    
            
}

async function getColumnsNumber() {
    const options = {
        url: `${GSHEETS_CONNECTOR_BASE_URL}/gsheet/1tYKljW2ztHQPOJsVLBE04PKkdGZ1X7t-aZXN-lQ7uoE?sheet=ACB&rowOffset=2&rowLimit=1`,
        headers: {
            Authorization: "Bearer R1NoZWV0Q29ubmVjdG9yOlNlcnZpY2VVc2Vy"
        },
    };
    return await request.get(options);
}

// # method that receives data from main and sends it using G-Sheet connector API
async function send(data, col) {
    const options = {
        url: `${GSHEETS_CONNECTOR_BASE_URL}/gsheet/1tYKljW2ztHQPOJsVLBE04PKkdGZ1X7t-aZXN-lQ7uoE`,
        headers: {
            Accept: "application/json",
            "Content-Type": "application/json",
            Authorization: "Bearer R1NoZWV0Q29ubmVjdG9yOlNlcnZpY2VVc2Vy"
        },
        json: {
            sheet: 'ACB',
            data: data,
            colOffset: col,
            clearRowLimit: 2,
            clearColOffset: col,
        }
    };
    await request.post(options);
}

run();
