const fs = require("fs"),
request = require("request-promise-native");
const AMPLIFY_API_BASE_URL = "https://api.amplify.ai/api/v1";

async function init() {
    try {

        const auth = await getAmplifyAuthToken("jake+readonlyadmin@amplify.ai", "xixujebofacu");

        if (auth && auth.success && auth.access_token) {
            const authToken = auth.access_token;

             const broadcastDetail = await getBroadcastDetail(authToken, "63d372b6ff86c4315608d162", "63d373133fcd7b31484b1c49",simplifyDate("2024-06-18 00:00:00+00:00"), simplifyDate("2024-06-27 00:00:00+00:00"));

             var broadcastIdSubscriberList = {};
             broadcastDetail.forEach(function(item,index){ broadcastIdSubscriberList[item.key] = item.broadcasts; })
             console.log(JSON.stringify(broadcastIdSubscriberList));
              }
    } catch (err) {
        console.log(err);
    }
}

async function getAmplifyAuthToken(username, password) {
    const options = {
        url: `${AMPLIFY_API_BASE_URL}/login`,
        headers: {
            Accept: "application/json",
            "Content-Type": "application/json"
        },
        json: {
            username,
            password
        }
    };
    return await request.post(options);
}

async function getBroadcastDetail(authToken, accountId, botId, startDate, endDate) {
    const options = {
        url: `${AMPLIFY_API_BASE_URL}/analytics/other`,
        headers: {
            Accept: "application/json",
            "Content-Type": "application/json",
              "x-access-token": authToken
        },
        json: {
    "filters": [],
    "startDate": startDate,
    "endDate": endDate,
    "accountId": accountId,
    "botId": botId,
    "aggregationFields": [
        "broadcasts",
        "sent",
        "delivered",
        "read",
        "engaged"
    ],
    "indexName": "broadcasts",
    "groupByField": "broadcastId",
    "sort": [
        {
            "broadcasts": {
                "order": "desc"
            }
        }
    ],
    "antiFilters": [
        {
            "field": "broadcastJobType",
            "eq": [
                "drip-broadcast"
            ]
        }
    ],
    "groupByBucketLimit": 10000

        }
    };
    return await request.post(options);
}

function simplifyDate(date) {
let splitDate = date.split(/-| /);
let popItem = splitDate.pop();
let simplifiedDate = splitDate.join("");
return simplifiedDate;
}

init();

