const fs = require('fs');
const request = require("request-promise-native");

async function run() {
    const accountIds = fs.readdirSync("./data")

    const csvArray = [], sheetArray = [["AccountId", "Rank", "Score", "Number of Users"]];
    csvArray.push("AccountNumber,Rank,Score,NumUsers");
    
    let i = 0;
    for(accountId of accountIds) {
        try {
            const leaderboard = JSON.parse(fs.readFileSync(`./data/${accountId}/leaderboard.json`).toString())
            if(leaderboard.length) {
                i++;
            }

            let rankNumber = 1;
            for(rank of leaderboard) {
                let rankScore = rank[0].score;
                csvArray.push(`${i},${rankNumber},${rankScore},${rank.length}`);
                sheetArray.push([accountId, rankNumber, rankScore, rank.length]);
                rankNumber++;
            }
        } catch (error) {
            console.log(`No leaderboard found for ${accountId}`);
        }
    }
    
    const csvString = csvArray.join('\n');
    
    fs.writeFileSync("leaderboard.csv",csvString);

    await writeToSheet("1je19pD4BVrOG8Lsgg6lAStOJ0-mlci3zGVdkgExOa94", "Generic", sheetArray);
};

async function writeToSheet(spreadsheetId, sheetName, data) {
	const GSHEETS_CONNECTOR_BASE_URL = "https://23pysf2rdf.execute-api.us-east-1.amazonaws.com/prod";
    const options = {
        url: `${GSHEETS_CONNECTOR_BASE_URL}/gsheet/${spreadsheetId}`,
        headers: {
            Accept: "application/json",
            "Content-Type": "application/json",
            Authorization: "Bearer R1NoZWV0Q29ubmVjdG9yOlNlcnZpY2VVc2Vy"
        },
        json: {
            sheet: sheetName,
            data
        }
    };
    await request.post(options);
}

run();
