const fs = require("fs"),
    request = require("request-promise-native");
const GSHEETS_CONNECTOR_BASE_URL = "https://23pysf2rdf.execute-api.us-east-1.amazonaws.com/prod";

async function init() {
    const sheetData = await JSON.parse(fs.readFileSync("./sheetData.json").toString());

    const sheetWriteResponse = await writeToSheet("1AnuEiYfwYUWD4T99oh-jDfoH3yvmNwDB-LHsCnnF_VU", "SMS Affiliates Last Touch", sheetData);

    console.log("Sheet write response: ", sheetWriteResponse);
}

async function writeToSheet(spreadsheetId, sheetName, data) {
    const options = {
        url: `${GSHEETS_CONNECTOR_BASE_URL}/gsheet/${spreadsheetId}`,
        headers: {
            Accept: "application/json",
            "Content-Type": "application/json",
            Authorization: "Bearer R1NoZWV0Q29ubmVjdG9yOlNlcnZpY2VVc2Vy"
        },
        json: {
            sheet: sheetName,
            data: data,
            rowOffset: 1
        }
    };
    return await request.post(options);
}

init();
